// compito.cpp
#include "to_debug_corretto.h"

Ristorante :: Ristorante (int n){
	
	if(n<=0)
		dim = - n + 1;
	// BUG
	// la sanitizzazione non è efficace
	else
	    dim = n;

    lista = new elem;
    lista = nullptr;
    postiliberi = dim;
} 

// BUG
// mancato const
void Ristorante::aggiungi(const char* s, int n){

	if (postiliberi >= n && lista == nullptr){

        postiliberi -= n;

        return;
	}

	// BUG
	// La possibilità che il cognome sia troppo lungo non viene presa in considerazione
	// Questa è solo una soluzione (con assunzione forte sulla diversità dei cognomi)
	char cognome[31];
	strncpy(cognome, s, 30);
	cognome[30] = '\0';

	insCoda (lista, cognome, n);
}

// BUG
// mancato const
void Ristorante::insCoda(elem*& L, const char *s, int n){

    if(L == nullptr){
        elem*q = new elem;
        q-> persone = n;
        strcpy(q->nome, s);
        L = q;
        q->pun = nullptr;

        return;
    }


    elem* q= L;
    while (q->pun != nullptr)
		q=q->pun;

    elem*r = new elem;
    r->persone = n;
    strcpy(r->nome, s);

	// BUG
	// mancata inizializzazione puntatore a prossimo elemento
	r->pun = nullptr;

    q->pun = r;

    return;
}

ostream& operator << (ostream& os, const Ristorante& R){

	//BUG
	// usa cout anziché os

	os << "Posti liberi "<< R.postiliberi<< ", in attesa";

	// BUG
	// la stampa non è corretta nel caso non vi sia nessuno in attesa ma
	// il ristorante non sia vuoto
    if (R.lista == nullptr){
        os << " nessuno"<< endl;
        return os;
    }

	// BUG
	// la stampa non richiedeva la parola "persone"
    for (elem* q = R.lista; q!= nullptr; q = q-> pun){
        os << ' ' << q->nome << '('<< q-> persone << ')'; 
    }

    os << endl;

    return os;
}

Ristorante& Ristorante::operator -=(int n){

	// BUG
	// mancato controllo dell'input
	if(n <= 0)
		return *this;

    postiliberi += n;

	// BUG x2
	// Il numero di gruppi fatti accedere può essere più di uno
	// non controlla se non vi sono gruppi in attesa
	while(lista != nullptr && lista->persone <= postiliberi){
        postiliberi -= lista->persone;
        delTesta(lista);            
    }

    return *this;
}

void Ristorante::delTesta(elem*& L){
    if (L == nullptr)
        return;

    if (L->pun == nullptr){
        L = nullptr;
        return;
	}

    elem* q=L;
    L = L->pun;
    delete q;
}

// BUG
// mancato const
void Ristorante::elimina(elem*& L, const char*s){
    if (strcmp(L->nome, s) == 0)
        delTesta(L);
        return;

    elem* prec = L;  
    elem* q = L->pun;

    for (; strcmp(q->nome, s) != 0 && q != nullptr; q = q->pun)
        prec=q;

    prec = q->pun;
    delete q;
}

// BUG
// mancato const
bool Ristorante::rinuncia(const char* cg){
    elem* p = lista;
    elem* q;     
    
	while(p != nullptr){
        if(strcmp(p->nome, cg) == 0){
            
            if (p == lista){
                lista = lista->pun;
                delete p;
				// BUG
				// non controlla se i successivi nella lista possano essere fatti accomodare
				while(lista != nullptr && lista->persone <= postiliberi){
					postiliberi -= lista->persone;
					delTesta(lista);            
				}
				// Righe inutili
                // p = lista;
                // q = p;
            }

            else{ 
                q->pun = p->pun;
                delete p;
				// Righe inutili
                //q = q->pun;
                //p = q;
            }
                    
	        return true;            
        }

        q = p;
        p = p->pun;
    }
	return false;
}

// BUG
// mancato const
Ristorante::Ristorante(const Ristorante& g){
	postiliberi = g.postiliberi;
	lista = nullptr;
	elem* coda = nullptr;

	for(elem* p = g.lista; p != nullptr; p = p->pun){
		elem* q = new elem;    
		strcpy(q->nome, p->nome);
		q->persone = p->persone;
		q->pun = nullptr;

		if(coda == nullptr)
			lista = q;
		else
			coda->pun = q;

		coda = q;
	}
}

void Ristorante::dealloca(elem*& L){
	// BUG
	// prec = q->pun sarebbe potuto essere nullptr 
	// e con q = prec seguito da q = q->pun avremmo potuto avere segfault
	// non fare mai distruttori liste con il for ma usare lo while
	
	/*    
	if (L == nullptr)
            return;
    
	elem* prec = L;
    elem* q = prec->pun;

    for (; q != nullptr; q = q->pun){
        prec = q->pun;
        delete q;
        q = prec;
    }
	*/

	elem* to_delete = L;

	while(L != nullptr){
		L = L->pun;
		delete to_delete;
		to_delete = L;	
	}
}

Ristorante::~Ristorante (){
    dealloca(lista);
}
