// compito.h

#include <iostream>
#include <cstring>
using namespace std;

struct elem { // lista che tiene conto dei gruppi in fila
        int persone;
        char nome[31]; // BUG: il vettore deve accomodare anche il terminatore di stringa
        elem* pun;
};

class Ristorante {
        int dim;
        int postiliberi;
        elem * lista;
        
        void insCoda(elem*& L, const char *s, int n);
        void delTesta(elem*& L);
        void dealloca(elem*& L);
        void elimina(elem*& L, const char*s);
        
    public:
		Ristorante (int n);
		void aggiungi (const char * s, int n);
		bool rinuncia (const char* s);
		friend ostream& operator<<(ostream & os, const Ristorante &);
		Ristorante & operator -=(int n);
		Ristorante(const Ristorante& g);
		~Ristorante(); 
};
